/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.AllDashboards");

dojo.require("dojo.i18n");

dojo.require("com.ibm.team.dashboard.web.client.internal.DashboardClient");
dojo.require("com.ibm.team.dashboard.web.ui.internal.Constants");
dojo.require("com.ibm.team.dashboard.web.util.internal.Util");
dojo.require("com.ibm.team.dashboard.web.ui.internal.AllTeamAreas");
dojo.require("com.ibm.team.dashboard.web.ui.internal.AllUsers");
dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");
dojo.require("com.ibm.team.dashboard.web.ui.internal.Constants");

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

(function() {

//
// Aliases
//
var Constants = com.ibm.team.dashboard.web.ui.internal.Constants;
var EventConstants = com.ibm.team.dashboard.web.ui.internal.Constants.Events.DashboardContainer;
var DashboardClient = com.ibm.team.dashboard.web.client.internal.DashboardClient;
var Util = com.ibm.team.dashboard.web.util.internal.Util;
var AllTeamAreas = com.ibm.team.dashboard.web.ui.internal.AllTeamAreas;
var AllUsers = com.ibm.team.dashboard.web.ui.internal.AllUsers;
var DashboardConstants = com.ibm.team.dashboard.web.ui.DashboardConstants;
var Constants = com.ibm.team.dashboard.web.ui.internal.Constants;

/**
 * The widget for the content area (right side) of the dashboard.
 */
dojo.declare("com.ibm.team.dashboard.web.ui.internal.AllDashboards",
	[dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/AllDashboards.html"),
	
	constructor: function() {
		// messages only used in constructor, don't hold reference
		var messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");
		this.allHeading = messages.allHeading;
		this.allTeams = messages.allTeams;
		this.allUsers = messages.allUsers;
	},
	init: function() {
		this._tabWrapper.style.display = "block";
		this._update();
	},
	select: function(tab, page) {
		this.tab = tab;
		if (page)
			this.page = page;
		this._update();
	},
	_update: function() {
		if (this.tab && this.tab == 1)
			this._selectAllUsersTab();
		else {
			this._selectAllTeamAreasTab();
		}
	},
	_selectAllTeamAreasTab: function() {
		dojo.addClass(this._allTeamAreasTab,"selectedTab");
		dojo.removeClass(this._allUsersTab,"selectedTab");
		this._updateContentArea(0);
	},
	_selectAllUsersTab: function() {
		dojo.addClass(this._allUsersTab,"selectedTab");
		dojo.removeClass(this._allTeamAreasTab,"selectedTab");
		if (this.page)
			this._allUsersLink.href = "#" + Constants.URL_PARAM_ACTION + "=" + DashboardConstants.ACTION_VIEW_ALL_DASHBOARDS + "&" + DashboardConstants.URL_PARAM_TAB + "=1" + "&page=" + this.page;
		this._updateContentArea(1);		
	},
	_updateContentArea: function(tab) {
		if (tab == 0) {
			if (!this._allTeamAreasWidget)
				this._allTeamAreasWidget = new AllTeamAreas();
			var node = this._allTeamAreasWidget.domNode;
		} else {
			if (!this._allUsersWidget)
				this._allUsersWidget = new AllUsers({page: this.page});
			else if (this.page)
				this._allUsersWidget.showPage(this.page);
			var node = this._allUsersWidget.domNode;
		}
		if (this._contentArea.firstChild)
			this._contentArea.replaceChild(node, this._contentArea.firstChild);
		else
			this._contentArea.appendChild(node);
	}
});
})();
