/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.common.MultipaneContentView");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.MultipaneContentController");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

(function() {

var checkNotNull		= net.jazz.ajax.toolbox.lang.checkNotNull;
var checkNonNegative	= net.jazz.ajax.toolbox.lang.checkNonNegative;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.common.MultipaneContentView",
	[dijit._Widget, dijit._Templated],
	{
		templatePath:    dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/common/templates/MultipaneContent.html"),
		// templateCssPath: dojo.uri.dojoUri("../com.ibm.team.workitem.web/ui/internal/view/common/templates/MultipaneContent.css"),
		currentWidget: null,
		parentController: null,
		// initialization
		postCreate: function() {
		 	this.controller = new com.ibm.team.workitem.web.ui.internal.view.common.MultipaneContentController(this);
			this._window_onscroll_handle = this.connect(window, "onscroll", "_handleScroll");
		},
		destroy: function() {
			this.disconnect(this._window_onscroll_handle);
			this.controller.destroy();			
 			this.inherited(arguments);
		},
		
		_handleScroll: function (e) {
			try {
				// When the back button is used, we get a scroll but are pointing to different content.
				// URL can have an extra tab attribute so use indexOf
				var url = "";
				if (this.currentWidget && this.currentWidget.getURL && this.currentWidget.getURL()) { // work item
					url = this.currentWidget.getURL();
				}
				else 
					if (this.currentWidget && this.currentWidget.href) { // query
						url = this.currentWidget.href;
					}
				
				// remove timestamps
				url = url.replace(/&t[s|q]=([0-9]+)/, "");
				loc = window.location.href.replace(/&t[s|q]=([0-9]+)/, "");
				if (url.indexOf(loc) != -1) {
					this.currentWidget.scrollTop = document.documentElement.scrollTop; // window.pageYOffset
					this.currentWidget.scrollLeft = document.documentElement.scrollLeft; // window.pageXOffset
				}
			} 
			catch (e) {
				console.debug("Error in MultipaneContentView._handleScroll");
			}
		}, 
		getWidgetCache: function() {
			return this.controller.getWidgetCache();	
		},
		showNextView: function() {
			return this._itemListWidget.showNextView();
		},
		setItemListWidget: function(aWidget) {
			this._itemListWidget = aWidget;
		},
		isWidgetAvailable: function(widgetId, instanceId) {
			return this.controller.getCachedWidget(widgetId, null, instanceId) != null;
		},
		getCachedWidget: function(widgetId, instanceId, isSimple, instanceUUID) {
			return this.controller.getCachedWidget(widgetId, null, instanceId, isSimple, instanceUUID);
		},  
		removeCachedWidget: function(widgetId, instanceId) {
			return this.controller.removeCachedWidget(widgetId, instanceId);
		},  
		showContent: function(widgetId, widget, instanceId, skipNavUpdate) {

			this.currentWidget = this.controller.getCachedWidget(widgetId, widget, instanceId);
			if (this.domNode.childNodes.length == 1) {
				this.domNode.replaceChild(this.currentWidget.domNode, this.domNode.firstChild);
			}
			else {
				dojox.data.dom.removeChildren(this.domNode);
				this.domNode.appendChild(this.currentWidget.domNode);
			}

			if(this.currentWidget.scrollTop) {
				window.scrollTo(this.currentWidget.scrollLeft, this.currentWidget.scrollTop);
			} else {
				window.scrollTo(0,0);
			}		
				
			var label = widget.getShortLabel ? widget.getShortLabel() : "";
			var url = widget.getURL ? widget.getURL() : window.location.href;
			if(!this.currentWidget.getURL && !this.currentWidget.href) {
				this.currentWidget.href = url;
			}
				
			var isDirty = widget.isDirty ? widget.isDirty() : false;
			var summary = widget.getSummaryLabel ? widget.getSummaryLabel() : "";
			if(!skipNavUpdate) {
				this._touchItem(instanceId, label, url, isDirty, summary);
			}

		}, 
	
		getCurrentWidget: function() {
			return this.currentWidget;
		},
		setIsDirty: function(widgetId, widget, instanceId, isDirty) {
			this.controller.setIsDirty(widgetId, widget, instanceId, isDirty);
			this._itemListWidget.addItem(instanceId, widget.getShortLabel(), widget.getURL(), isDirty, widget.getSummaryLabel(), widget.getIconURL());
		},
		_addItem: function(widgetId, widget, instanceId, isDirty){
			if(widgetId == "__jazzWorkItemWelcome") return;
			this._itemListWidget.addItem(instanceId, widget.getShortLabel(), widget.getURL(), isDirty, null, widget.getIconURL());
		},
		_removeItem: function(instanceId){				
			this._itemListWidget.removeItem(instanceId);
		},
		_touchItem: function(instanceId, label, url, isDirty, summary){
			this._itemListWidget.touchItem(instanceId,label, url, isDirty, summary);
		},
		getOldestNonDirtyId: function(notThisId) {
			return this._itemListWidget.getOldestNonDirtyId(notThisId);
		}
			
	}
);

})();