/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.EstimateAndCorrectionAttributePart");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.TextWidget");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
/*
 * This is a wrapper widget that provides the presentation and value
 * processing for Duration, presented in 
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
var TOOLTIP;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.EstimateAndCorrectionAttributePart",
	[dijit._Widget, dijit._Templated],
	{
		
		templateString: '<div class="DurationAttributePart NarrowWidget EstimateAndCorrectionAttributePart">' +
						'</div>',

	constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
			TOOLTIP= this.messages.msgEstimateValidation;
		},
		postCreate: function() {
			/*
			 * values[0] is the Duration, values[1] is correctedEstimate
			 *    label
			 *    validationRegex
			 *    id
			 */
			
			
			this.estimate = this.values[0];
			if(!this.estimate && this.workItem && this.workItem.attributes) {
				this.estimate = this.workItem.attributes.duration;
				this.estimate._attributeId = "duration";	
			}
					
			if(!this.estimate._attributeId && this.attributeId) {
				this.estimate._attributeId = this.attributeId;
			}
			
			this.correction = this.values[1];
			if(!this.correction && this.workItem && this.workItem.attributes) {
				this.correction = this.workItem.attributes.correctedEstimate;
				this.correction._attributeId = "correctedEstimate";	
			}

			
			if(!this.correction || !this.correction._attributeId || !this.estimate || !this.estimate._attributeId) {
				console.debug("Missing estimate or correction in EstimateAndCorrectionAttributePart");
				return;
			}
			
			var creationArgs = {
						parentWidget: this,
						parentController: this.parentController,
						presentation: {
							attribute: {
								attributeTypeId: "ShortString"
							}
						},
						selection:  [ {
							id: this.estimate.label
							} 
						 ] ,
						 converter: this._TextWidget_durationConverter,
						 converterParms: {
						 		toolTip: TOOLTIP,
								value: this.estimate
						 }
					};
					
			this.estimateWidget = new com.ibm.team.workitem.web.ui.internal.view.layout.TextWidget(creationArgs);

			this.domNode.appendChild(this.estimateWidget.domNode);
			
			var cDiv = document.createElement("DIV");
			
			var cSpan = document.createElement("SPAN");
			cSpan.appendChild(document.createTextNode(this.messages.labelCorrection));
			
			cDiv.appendChild(cSpan);
			
			creationArgs = {
						parentWidget: this,
						parentController: this.parentController,
						presentation: {
							attribute: {
								attributeTypeId: "ShortString"
							}
						},
						selection:  [ {
							id: this.correction.label
							} 
						 ] ,
						 converter: this._TextWidget_durationConverter,
						 converterParms: {
						 		toolTip: TOOLTIP, 
								value: this.correction
						 }
					};
					
			this.correctionWidget = new com.ibm.team.workitem.web.ui.internal.view.layout.TextWidget(creationArgs);

			cDiv.className = "EstimateCorrectionDiv";
			dojo.addClass(this.estimateWidget.domNode,"EstimateWidget");
			this.estimateWidget._textInput.className = "EstimateInput";
			cSpan.className = "EstimateCorrectionSpan";

			if(this.parentController.pageController.isGuest()) {
				dojo.addClass(this.correctionWidget._textInput, "GuestField");
				dojo.addClass(this.estimateWidget._textInput, "GuestField");
			}

			cDiv.appendChild(this.correctionWidget.domNode);
			this.domNode.appendChild(cDiv);

		},
		destroy: function() {
			if(this.estimateWidget.destroy) this.estimateWidget.destroy();
			if(this.correctionWidget.destroy) this.correctionWidget.destroy();
		},
		setReadOnly: function(isReadOnly) {
			this.estimateWidget.setReadOnly(isReadOnly);
			this.correctionWidget.setReadOnly(isReadOnly);
		},
		getFormElementValues: function(formElements) {
			var value = this.estimateWidget._textInput.value;
			if(value && this.estimate._attributeId) {
					formElements[this.estimate._attributeId] = value;
				} else {
					formElements[this.estimate._attributeId] = "";
				}
			value = this.correctionWidget._textInput.value;
			if(value && this.correction._attributeId) {
					formElements[this.correction._attributeId] = value;
				} else {
					formElements[this.correction._attributeId] = "";
				}
		},
		setFormElementValues: function(retainedState){
			var value = retainedState[this.estimate._attributeId];
			if(value) {
				this.estimateWidget._textInput.value = value;
			}
			var value = retainedState[this.correction._attributeId];
			if(value) {
				this.correctionWidget._textInput.value = value;
			}
			},
	     getValue: function() {
			try {
				var value1 = this.estimateWidget._textInput.value;
				var value2 = this.correctionWidget._textInput.value;
				return [ value1 , value2 ];
			} 
			catch (e) {
				console.debug("Error getting estimate and correction values." );
			}
			return []
		 },
	//* This runs in the context of TextWidget
		//
		_TextWidget_durationConverter: function (value, parms, isGettingValidValue) {
			return this.parentWidget._durationConverter(value, parms, isGettingValidValue);
		},
		_durationConverter: function (value, parms, isGettingValidValue) {
			var valid = false;
			if(value && parms.value && parms.value.validationRegex) {
				try{
					
					var regex = new RegExp("^" + parms.value.validationRegex + "$");
 					valid = value.search(regex) != -1;
//				valid = value.search(/^(([0-9]+(\.[0-9])?|\.[0-9]+)\s*(milliseconds|millisecond|millisecs|millisec|minutes|seconds|minute|second|weeks|hours|days|week|hour|mins|secs|day|wks|hrs|min|sec|ds|wk|ws|ms|d|w|h|m|s)\s*)*$/) != -1;
				} catch(e) {
					console.debug(dojo.string.substitute(this.messages.errorInvalidRegex, [this.validationRegex ]));
					valid = true;
				}

			}
			if(isGettingValidValue) {
				if(!value || value.length == 0) {
					return "";
				}				
				return value;
			}

			return {isCustom: true, isValid: valid };
		}
	}
);

})();
