/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.HistoryPart");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SectionMenuWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SectionMenuDropDownActionWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
/*
 * This is a wrapper widget that shows the History Section
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
var WorkItemClient = com.ibm.team.workitem.web.client.internal.WorkItemClient;
var EditorUtil = com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;
var WorkItemUtil = com.ibm.team.workitem.web.client.util;
var ServiceResponseHandler 	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var KEY_MAP = {
		updateLinks: "Links", // %NON-NLS-1%
		updateApprovals: "Approvals", // %NON-NLS-1%
		updateAttributes: "Details" // %NON-NLS-1%
	}

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.HistoryPart",
	[dijit._Widget, dijit._Templated],
	{
		
		templateString: '<div class="HistoryPart SectionPart">' +
						'<div dojoAttachPoint="_pendingChangesNode"></div>' +
						'<span dojoAttachPoint="_sectionMenuNode"></span>' +
						'<div dojoAttachPoint="_historyNode"></div>' +
						'</div>',

		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
			
		},
		postCreate: function() {	
			this._historyNode.innerHTML = this.messages.busyLoading; /* innerHTML OK */
			this._historyNode.style.color = "#CCCCCC";

			this._isInitialized = false;

		},
		destroyWidget: function() {
			this.resetWidget();
			this.destroy();
		},
		resetWidget: function() {
			this.parentController.pageController.removeAllMouseListeners(this);
		},
		/*
		 * Lazy load the tab when it is shown
		 */
		showWidget: function() {

			// If we are in debug mode, always refresh		
			if(location.href.indexOf("debug=true") != -1) {
				this.refresh(true);
				this.parentWidget.isShown = false; // refresh each time it is shown
			} else { // only show history once
				if(this._isInitialized) return;
				this._isInitialized = true;
				this.refresh(false);
			}
		},
		// This function is for debugging and is not string separated
		_showPendingCommands: function() {
		
			dojox.data.dom.removeChildren(this._pendingChangesNode);
			var appArgs= this.parentController._getSaveAppArgs();		
			
			var hasArgs = false;

			var node;
			node = document.createElement("DIV");
			var html = "";
		
			if(appArgs.action && appArgs.action.length > 4) {
				    hasArgs = true;
					html = html + "Action: <B>" + appArgs.action + "</B><BR>";  // %NON-NLS-1%
			}

			if(appArgs.attributeIdentifiers && appArgs.attributeIdentifiers.length > 0) {
				hasArgs = true;
				var cmd;
				html = html +  "Attributes<BR>";  // %NON-NLS-1%
				for(var i=0; i<appArgs.attributeIdentifiers.length;i++) {
					cmd = {
						cmd: appArgs.attributeIdentifiers[i],
						name: appArgs.attributeValues[i]
					}
 				    html= html + this._formatCommand(cmd);
				}				
			}

			var saveCommands= this.parentController._getSaveCommands();
			for(var key in saveCommands) {
				hasArgs = true;
				var keyName = KEY_MAP[key] ? KEY_MAP[key] : key;
				html = html +  "<B>" + keyName + "</B>"+ this._formatType(saveCommands[key]);  // %NON-NLS-1% 
			}
	
			node.innerHTML = html + "<BR>";
			
			if(!hasArgs) return;
			var heading=document.createElement("SPAN");
			heading.innerHTML="<B>Pending Changes</B><BR><BR>"; //innerHTML OK  %NON-NLS-1%
			this._pendingChangesNode.appendChild(heading);
			this._pendingChangesNode.appendChild(node);
		},
		_formatType: function(commands) {
			var html = "<BR>";
			for(var i=0;i<commands.length;i++) {
				html += this._formatCommand(commands[i]);
			}
			return html;
		},
		_formatCommand: function(saveCommand) {
			if(!saveCommand ) return;
			var type = saveCommand.type ? " <B>" + EditorUtil.getSafeText(saveCommand.type) + "</B>" : "";
			var name = saveCommand.name ? ": " + saveCommand.name : "";
			var cmd = saveCommand.cmd ? saveCommand.cmd : "";
			var result = "&nbsp;&nbsp;" + cmd + type + EditorUtil.getSafeText(name) + "<BR>"; 
				for (var key in saveCommand) {
					if(key == "cmd" || key=="name" || key=="type" | key=="itemId") continue;
					if(key == "param") {
						 result += this._formatCommand(saveCommand[key]);  
					} else {
						if(dojo.isArray(saveCommand[key])) {
							result += "&nbsp;&nbsp;&nbsp;&nbsp;" 
								+ EditorUtil.getSafeText(key) + "(" +saveCommand[key].length + ")";							
						} else {
							result += "&nbsp;&nbsp;&nbsp;&nbsp;" 
								+ EditorUtil.getSafeText(key) 
								+ ": " 
								+ EditorUtil.getSafeText(saveCommand[key]) + "<BR>";
						}						
					}

				}
			return result;
		},
		/*
		 * Setup the page and read the states and types 
		 */
		refresh: function(showPendingChanges) {
			this.resetWidget();
			if(showPendingChanges) {
				this._showPendingCommands();
			}
			
			this._refreshHistory();
		},
		_refreshHistory: function(){
			this._historyNode.style.color = "#CCCCCC";
			if(this.workItem.id < 0) { // new work item
				dojox.data.dom.replaceChildren(this._historyNode, document.createTextNode(this.messages.labelNoHistory));
				return;
			} else {
				dojox.data.dom.replaceChildren(this._historyNode, document.createTextNode(this.messages.busyLoading));
			}
			
			var self = this;
			var handlerObj = {
				historyHandler: function(workItem){
					self._refreshHistory2(workItem.changes);
				},
				error: function(error){
					dojox.data.dom.replaceChildren(self._historyNode, document.createTextNode(this.messages.errorLoadingHistory));
					self.handleError(error, this.messages.errorLoadingHistory);
				}
			};
			
			var responseHandler = new ServiceResponseHandler(handlerObj, "historyHandler", "error");
			
			var args = {
				id: this.parentController._workItem.id,
				includeAttributes: false,
				includeLinks: false,
				includeApprovals: false,
				includeHistory: true
			};
			
			WorkItemClient.getWorkItem(responseHandler, args);
		},
		handleError: function(error, msg) {
			console.debug(this.messages.errorLoadingHistory  + " - " + msg);
		},
		_refreshHistory2: function(changes) {
			dojox.data.dom.removeChildren(this._historyNode);
			this._historyNode.style.color = "";
			if(!changes || changes.length ==0) return;
			
			for(var i=changes.length-1;i>=0; i-- ) {
				this._formatChange(changes[i]);	
			}
		},
		_formatChange: function(change) {
			this._historyNode.appendChild(document.createElement("HR"));
			var headerNode=document.createElement("DIV");
			var dateString = WorkItemUtil.getAllTimestamps(change.modifiedDate).formattedTimestamp;
			headerNode.appendChild(document.createTextNode(dojo.string.substitute(this.messages.msgHistoryChangeBy, [change.modifiedBy.name , dateString])));
			headerNode.appendChild(document.createElement("BR"));
			headerNode.appendChild(document.createElement("BR"));
			var contentNode=document.createElement("DIV");
			contentNode.className = "HistoryItem";
			/*
			 * Walk this dom to add classes to the TD's
			 */
			try{
				contentNode.innerHTML = change.content;
				var rows = contentNode.getElementsByTagName("TR");
				for(var i=0;i<rows.length;i++) {
					if (rows[i] && rows[i].childNodes.length > 0) {
						for (var j = 0; j < rows[i].childNodes.length; j++) {
							if (rows[i].childNodes[j].tagName.toLowerCase() == "td") {
								rows[i].childNodes[j].className = "HistoryColumn"+j;
							}
						}
					}
				}
			} catch(e) {
				
			}

			if(contentNode.firstChild && contentNode.firstChild.tagName.toLowerCase() == "table") {
				contentNode.firstChild.cellPadding = 0;
				contentNode.firstChild.cellSpacing = 0;
			}
			this._historyNode.appendChild(headerNode);
			this._historyNode.appendChild(contentNode);
		},

		//
		// Part API Metnods
		//
		

		setReadOnly: function(isReadOnly) {
		},
		getFormElementValues: function(formElements) {
		},
		setFormElementValues: function(retainedState){
			},
		/*
		 * Return an array  of commands. See work item 40464.
		 *
		 */ 
		 getSaveCommands: function () {
		 },
	     getValue: function() {
		 }
	}
);

})();
