/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.TabContributedPage"); //$NON-NLS-1$

dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojox.data.dom"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.core.internal.loader"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.ImageClient"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.contribution.ContributedTab"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.Tab"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var loader				= net.jazz.ajax.core.internal.loader;
var ContributedTab		= com.ibm.team.apt.web.ui.contribution.ContributedTab;
var Tab					= com.ibm.team.apt.web.ui.internal.view.plan.Tab;

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.TabContributedPage", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.Tab], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	
	
	_widgetId: null,
	
	constructor: function() {
		this._isShown= false;
		this._widget= null;
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	postCreate: function() {
		if (dojo.exists(this._widgetId)) {
			this._showWidget();
		} else {
			var progressController= this._getServiceCallController();
			var messageId= progressController.setProgressMessage(MSGS.MONITOR_LOAD_CONTRIBUTEDPAGE)
			loader.load_async(this._widgetId, dojo.hitch(this, function(){
				try {
					try {
						this._showWidget();
					} catch (e) {
						this._handleWidgetError(e);
					}
				} finally {
					progressController.removeProgressMessage(messageId);
				}
			}));
		}
	},

	// ---- Tab.js implementation ------------------------------------------------------------------------------------------

	widgetAboutToShow: function() {
		if (this._widget != null) {
			this._widget.onShowTab();
		}
		this._isShown= true;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_showWidget: function() {
		var ctor= dojo.getObject(this._widgetId);
		this._widget= new ctor(ContributedTab.constructorArgs(this._iterationPlanPage, this._serviceCallController));
		this.domNode.appendChild(this._widget.domNode);
		
		if (this._isShown) {
			this._widget.onShowTab();
		}
	},

	_handleWidgetError: function(e) {
		// TODO improve error handling
		console.log(e);
		alert(MSGS.CONTRIBUTEDPAGE_ERROR_LOADING);
	},

	__sentinel: null // terminates this class definition
});

/**
 * This helper method creates the arguments object for the widget's constructor.
 * @return {Object} a widget private object to be passed in as a constructor argument
 */
com.ibm.team.apt.web.ui.internal.view.plan.TabContributedPage.constructorArgs= function(iterationPlanPage, id, name, widgetId, serviceCallController) {
	var result= {
		_widgetId: widgetId
	};

	return dojo.mixin(result, Tab.constructorArgs(iterationPlanPage, id.replace(/\./g, "_"), name, serviceCallController)); //$NON-NLS-1$
};

})();
