/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.GroupModeTopLevel"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.SortModes"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.AbstractGroupMode"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.Columns"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var Columns				= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.Columns;
var SortModes			= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.SortModes;

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.GroupModeTopLevel", //$NON-NLS-1$
			  com.ibm.team.apt.web.ui.internal.view.plan.planneditems.AbstractGroupMode, {

	_columns: [Columns["summary"], Columns["estimate"], Columns["priority"], Columns["owner"], Columns["id"]], //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	_myFolders: null,

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getGroupModeId: function() {
		return "toplevel"; //$NON-NLS-1$
	},

	getGroupModeLabel: function() {
		return MSGS.GROUPMODE_TOPLEVEL;
	},
	
	getSortModes: function() {
		return [SortModes.mysortorder, SortModes.priority, SortModes.estimate];
	},

	getColumns: function() {
		return this._columns;
	},

	getGroupId: function(workItemStack) {
		var workItem= workItemStack[workItemStack.length - 1];
		return workItem.auxiliary ? null : workItem.myFolderId;
	},

	getGroupDescription: function(groupId) {
		return this._getMyFolders()[groupId];
	},
	
	getGroupSorter: function() {
		return dojo.hitch(this, this._groupSortFn);
	},

	getDefaultGroupIds: function() {
		var result= [];
		
		for (var folderId in this._getMyFolders()) {
			result.push(folderId);
		}

		return result;
	},

	geWorkItemWidgetOptions: function(workItem) {
		var result= null;
		if (workItem.isTopLevelPlanItem() || workItem.isProgressPlanItem()) {
			result= {
				overrideColumn: {
					column: Columns["estimate"], //$NON-NLS-1$
					replacement: Columns["progress"], //$NON-NLS-1$
					columnSpan: 1
				}
			}
		}
		return result;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_getMyFolders: function() {
		if (this._myFolders == null) {
			myFolders= {};
			
			var processFolders= function(folders, parentFolders) {
				for (var i= 0; i < folders.length; i++) {
					var folder= folders[i];
					var description= {
						path: parentFolders,
						name: folder.label,
						index: folder.index,
						image: "" //$NON-NLS-1$
					};

					myFolders[folder.folderId]= description;
					
					if (dojo.isArray(folder.subFolders)) {
						var myPath= new Array();
						myPath.push.apply(myPath, parentFolders);
						myPath.push(folder.folderId);
						
						processFolders(folder.subFolders, myPath);
					}
				}
			}
			
			processFolders(this._plannedItemsPage.getMyFolders(), []);
			this._myFolders= myFolders;
		}
		
		return this._myFolders;
	},

	_groupSortFn: function(groupNodeA, groupNodeB) {
		var indexA= groupNodeA.getNodeValue().index;
		var indexB= groupNodeB.getNodeValue().index;
		
		return indexA - indexB;
	},

	__sentinel: null // terminates this class definition
});


})();
